﻿using System;
using System.Diagnostics;
using System.ServiceModel;

using TestWCFLibrary;

namespace TestWCFClient
{
    /// <summary>
    /// 프로그램
    /// </summary>
    public class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Stopwatch stopWatch = new Stopwatch();

            Console.WriteLine("HTTP 통신을 시작합니다.");

            stopWatch.Start();

            CommunicateHTTP();

            stopWatch.Stop();

            Console.WriteLine("HTTP 통신을 종료합니다.");

            Console.WriteLine("HTTP 통신 시간 : " + stopWatch.Elapsed.ToString());

            stopWatch.Reset();

            Console.WriteLine("TCP 통신을 시작합니다.");

            stopWatch.Start();

            CommunicateTCP();

            stopWatch.Stop();

            Console.WriteLine("TCP 통신을 종료합니다.");

            Console.WriteLine("TCP 통신 시간 : " + stopWatch.Elapsed.ToString());

            Console.ReadKey();
        }

        #endregion

        #region HTTP 통신하기 - CommunicateHTTP()

        /// <summary>
        /// HTTP 통신하기
        /// </summary>
        private static void CommunicateHTTP()
        {
            ChannelFactory<IHelloWorld> channelFactory = new ChannelFactory<IHelloWorld>("HttpHelloWorld");

            IHelloWorld helloWorld = channelFactory.CreateChannel();

            for(int i = 0; i < 100; i++)
            {
                string result = helloWorld.SayHello();
            }

            (helloWorld as IDisposable).Dispose();
        }

        #endregion
        #region TCP 통신하기 - CommunicateTCP()

        /// <summary>
        /// TCP 통신하기
        /// </summary>
        private static void CommunicateTCP()
        {
            ChannelFactory<IHelloWorld> channelFactory = new ChannelFactory<IHelloWorld>("TcpHelloWorld");

            IHelloWorld helloWorld = channelFactory.CreateChannel();

            for(int i = 0; i < 100; i++)
            {
                string result = helloWorld.SayHello();
            }

            (helloWorld as IDisposable).Dispose();
        }

        #endregion
    }
}